"{ Package: 'stx:libbasic2' }"

"{ NameSpace: Smalltalk }"

Matrix variableSubclass:#TwoDimensionalMatrix
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-MultiDimensional'
!


!TwoDimensionalMatrix methodsFor:'accessing'!

subMatrix: aPoint
    | retval retRow retCol |

    retval := Matrix newForRows:(self rows-1) cols:(self columns-1).
    retRow := 1.
    retCol := 1.

    1 to: self rows do: [ :r |
        r ~= aPoint x ifTrue: [
            1 to: self columns do: [ :c |
                c ~= aPoint y ifTrue: [
                    retval _at: retRow at: retCol put: (self _at: r at: c).
                    retCol := retCol + 1 
                ] 
            ].
            retRow := retRow + 1 
        ].
        retCol := 1 
    ].
    ^ retval
! !

!TwoDimensionalMatrix methodsFor:'matrix operations'!

minor: aPoint
    ^ (self subMatrix: aPoint) determinantByCofactors
! !

!TwoDimensionalMatrix methodsFor:'queries'!

cofactor:aPoint
    (aPoint x + aPoint y) odd
            ifTrue: [ ^ -1 * (self minor: aPoint) ]
            ifFalse: [ ^ self minor: aPoint ]
! !

!TwoDimensionalMatrix class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

